﻿* Encoding: UTF-8.
*Compare sequences
*SPSS macros by Kirill Orlov
*kior@akado.ru, ttnphns@gmail.com
*https://www.spsstools.net/en/KO-spssmacros
*All rights reserved.

*/*!KO_SEQSIM*/vers3***************************************************************************************.
define !KO_seqsim(docvar= !charend('/') /wordvar= !charend('/') /compare= !charend('/') /chmaxw= !charend('/') /chminw= !charend('/')
                 /chpass= !charend('/') /chbward= !charend('/') /trv= !charend('/') /trsm= !charend('/') /trotr= !charend('/')
                 /diag= !charend('/') /diagls= !charend('/') /rescrnd= !charend('/') /method= !charend('/')
                 /dlen= !charend('/') /divisor= !charend('/') /savem1= !charend('/') /savem2= !charend('/') /savemxaw= !charend('/')
                 /print= !charend('/') /wmax= !charend('/') /dataset= !charend('/') /newdata= !charend('/'))
!let !ok= 1 !let !wprint= 0 !let !square= 0 !let !w_= 'w' !let !firstext= 0 !let !mbfrac= 0 !let !trvnfe= 0 !let !trsmnfe= 0
exec.
title '!KO_SEQSIM'.
!if (!compare='FIRSTEXT') !then !let !firstext= 1
 !if (!dataset=!null) !then !let !ok= 0
- echo ''.
- echo '>ERROR. COMPARE=FIRSTEXT требует п/к DATASET.'.
 !ifend
 !if (!savemxaw<>!null !or !savem2<>!null) !then !let !ok= 0
- echo ''.
- echo '>ERROR. Задание SAVEMXAW или SAVEM2 несовместимо с COMPARE=FIRSTEXT.'.
 !ifend
!else !if (!trsm<>!null !and !dataset=!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. Задание TRSM требует п/к DATASET.'.
!else !if (!head(!method)<>'GREEDY' !and !head(!method)<>'HUNGAR' !and !head(!method)<>'MXTRACE' !and !head(!method)<>'MXCHW'
           !and !head(!method)<>'SUM' !and !head(!method)<>'MXW' !and !head(!method)<>'MEANPW') !then !let !ok= 0
-echo ''.
-echo '>ERROR. Не задано или неверно задано METHOD.'.
!else !if (!head(!method)<>'GREEDY' !and !tail(!method)<>!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. Только после METHOD=GREEDY могут идти кл. слова (REORD или PRINT).'.
!else !if ((!method='SUM' !or !method='MXW' !or !method='MEANPW') !and !dlen<>'NONE') !then !let !ok= 0
-echo ''.
-echo '>ERROR. METHOD= SUM/MXW/MEANPW требуют DLEN=NONE.'.
!else !if ((!trv<>!null !or !trsm<>!null !or !diag<>!null) !and !index(!method,'PRINT')>0) !then !let !ok= 0
-echo ''.
-echo '>ERROR. METHOD=...PRINT несовместимо с заданием TRV/TRSM или DIAG,'.
-echo '>т.е. когда значения в матрице совстреч могут быть нецелочисленны.'.
!else !if ((!head(!chmaxw)='NOLIM' !or !tail(!chminw)=' INI') !and !index(!method,'PRINT')>0) !then !let !ok= 0
-echo ''.
-echo '>ERROR. METHOD=...PRINT несовместимо с CHMAXW=NOLIM или с CHMINW=...INI.'.
!else !if (!head(!chmaxw)='SQUARE' !or !tail(!chmaxw)<>!null !and !tail(!chmaxw)<>' SQUARE') !then !let !ok= 0
-echo ''.
-echo '>ERROR. Неверно задано CHMAXW.'.
!else !if (!head(!chminw)='INI' !or !tail(!chminw)<>!null !and !tail(!chminw)<>' INI') !then !let !ok= 0
-echo ''.
-echo '>ERROR. Неверно задано CHMINW.'.
!else !if (!diag<>!null !and !chbward='YES') !then !let !ok= 0
-echo ''.
-echo '>ERROR. Задание DIAG несовместимо с CHBWARD=YES.'.
!else !if (!rescrnd<>!null !and !rescrnd<>1 !and !rescrnd<>2 !and !rescrnd<>3) !then !let !ok= 0
-echo ''.
-echo '>ERROR. RESCRND может быть только целым 1, 2 или 3.'.
!else !if (!trv<>!null !and !trsm<>!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. Нельзя задавать обе: TRV и TRSM.'.
!else !if (!trv<>!null !and !chmaxw<>!null !and !chmaxw<>1 !and !chpass=!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. Не задано или неверно задано CHPASS.'.
!else !if (!trsm<>!null !and !chmaxw<>!null !and !chmaxw<>1 !and !tail(!chpass)=!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. Не задано или неверно задано CHPASS.'.
!else !if ((!chmaxw=!null !or !head(!chmaxw)=1) !and !method='MXCHW') !then !let !ok= 0
-echo ''.
-echo '>ERROR. METHOD=MXCHW требует задания (или другого задания) CHMAXW.'.
!else !if (!method='MXCHW' !and !chbward='YES') !then !let !ok= 0
-echo ''.
-echo '>ERROR. METHOD=MXCHW несовместим с CHBWARD=YES.'.
!else !if ((!divisor<>!null !or !wmax<>!null) !and !dlen='NONE') !then !let !ok= 0
-echo ''.
-echo '>ERROR. П/к DIVISOR, WMAX возможны только при DLEN не NONE.'.
!else !if (!diagls<>!null !and !tail(!diagls)=!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. Неверно задано DIAGLS.'.
!ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend
!if (!ok) !then
-oms /select headings /destination viewer= no.
 !if (!diag<>!null !or !trv<>!null !or !trsm<>!null) !then !let !mbfrac= 1 !ifend
 !if (!trv<>!null !and !not !firstext) !then !let !trvnfe= 1 !ifend
 !if (!trsm<>!null !and !not !firstext) !then !let !trsmnfe= 1 !ifend
 !if (!trotr=!null) !then !let !trtr= 1 !else !let !trtr= !trotr !ifend
 !if (!rescrnd<>!null !and !not !mbfrac) !then
- echo ''.
- echo '>WARNING. RESCRND игнорируется, если не задано ни TRV/TRSM, ни DIAG.'.
 !ifend
 !if (!chpass<>!null !and !not(!trvnfe !or !trsmnfe)) !then
- echo ''.
- echo '>WARNING. CHPASS игнорируется: не задано TRV/TRSM.'.
 !ifend
 !if (!tail(!chminw)=' INI' !and (!head(!chminw)=1 !or !head(!chminw)=2)) !then
- echo ''.
- echo '>WARNING. CHMINW= 1 INI или 2 INI эквивалентно CHMINW= 1.'.
 !ifend
 !if ((!divisor<>!null !or !wmax<>!null) !and (!chmaxw=!null !or !head(!chmaxw)=1)) !then
- echo ''.
- echo '>WARNING. DIVISOR, WMAX игнорируются при незаданном CHMAXW и CHMAXW=1.'.
 !ifend
 !if (!diagls<>!null !and !diag=!null) !then
- echo ''.
- echo '>WARNING. DIAGLS игнорируется, т.к. не задано DIAG.'.
 !ifend
 !if (!dataset='RENAME') !then !let !dtst= 'KO_seqsim#$._'
- dataset name KO_seqsim#$._.
 !else !let !dtst= !dataset
 !ifend
-set results none errors none.
-del var word_.#$.
-del var nseqw_.#$.
-del var relev_.#$.
-set results list errors list.
-weight off.
 !if (!trvnfe !and !trv<>'AUTO') !then
- add files /file= * /file= !trv /rename (word_=!wordvar).
 !ifend
-temp.
-val lab !wordvar.
-autorecode !wordvar /into word_.#$
   /blank= miss !if (!trsmnfe) !then /save templ= 'temp_KO_seqsim_1.sat' !ifend !if (!print<>!null) !then /print !ifend.
 !if (!print<>!null) !then
- echo '>NOTE. Missings/blanks (разрывы), если были, перекодированы в случ. отриц. числа.'.
- echo ''.
 !ifend
-var lab word_.#$ !quote(!conc(!wordvar,' Autorecoded')).
-if miss(word_.#$) word_.#$= -(unif(1)+1).
-echo '!KO_SEQSIM создал во входящем массиве переменные/ую с окончанием имени _.#$.'.
-echo 'После завершения работы макроса их можно удалить.'.
 !if (!trvnfe) !then
  !if (!trv='AUTO') !then
-  autorecode !docvar /into seq_.#$.
-  rank seq_.#$ by word_.#$ /rank into nseqw_.#$ /ties= condense /print= no.
-  aggreg /out= * mode= add over= yes /break= word_.#$ /nseqw_.#$= max(nseqw_.#$).
-  format nseqw_.#$ (f8).
-  del var seq_.#$.
-  do if nseqw_.#$>1.
-   comp relev_.#$= lg10(2)/lg10(nseqw_.#$).
-  else.
-   comp relev_.#$= 0.
-  end if.
-  do if word_.#$<0.
-   comp relev_.#$= $sysmis.
-   comp nseqw_.#$= $sysmis.
-  end if.
-  var lab nseqw_.#$ 'Number of documents containing this term' relev_.#$ 'Term relevance'.
  !else
-  aggreg /out= * mode= add /break= word_.#$ /relev_.#$= max(relev_).
-  del var relev_.
-  var lab relev_.#$ 'Term relevance'.
-  select if !docvar<>' '.
-  if sysmis(relev_.#$) and word_.#$>0 relev_.#$= !trtr.
  !ifend
 !ifend
 !if (!trsmnfe) !then
- get file= !trsm.
- autorecode word_ /into word_.#$ /blank= miss /apply templ= 'temp_KO_seqsim_1.sat'.
- save outfile= 'temp_KO_seqsim_2.sav' /drop= word_ varname_.
- dataset activ !dtst.
 !ifend
-echo ''.
-echo 'Running...'.
-set mxloops 1E9.
-matrix.
-comp ok= 1.
 !if (!not !firstext) !then
  !if (!chmaxw=!null) !then !let !mxw= 1 !else !let !mxw= !head(!chmaxw) !ifend
  !if (!chminw=!null) !then !let !mnw= 1 !else !let !mnw= !head(!chminw) !ifend
  !if (!mxw<>'NOLIM') !then
-  do if !mxw<1 or !mxw<>trunc(!mxw) or !mxw<!mnw.
-   print /title '>ERROR. CHMAXW должно быть полож. целым >=1 (п/у =1), и CHMAXW>=CHMINW.'.
-   comp ok= 0.
-  end if.
  !ifend
- do if !mnw<1 or !mnw<>trunc(!mnw).
-  print /title '>ERROR. CHMINW должно быть полож. целым >=1.'.
-  comp ok= 0.
- end if.
  !if (!trvnfe !and !mxw<>1) !then
   do if !head(!chpass)<=0 or !head(!chpass)>1.
-   print /title '>ERROR. Значение CHPASS должно быть в диапазоне (0,1].'.
-   comp ok= 0.
-  end if.
  !else !if (!trsmnfe !and !mxw<>1) !then
   do if !head(!chpass)<=0 or !head(!chpass)>1 or !tail(!chpass)<=0 or !tail(!chpass)>1.
-   print /title '>ERROR. Значения CHPASS должны быть в диапазоне (0,1].'.
-   comp ok= 0.
-  end if.
  !ifend !ifend
  !if ((!trvnfe !or !trsmnfe) !and !trotr<>!null) !then
-  do if !trotr<0 or !trotr>1.
-   print /title '>ERROR. Значение TROTR должно быть в диапазоне [0,1].'.
-   comp ok= 0.
-  end if.
  !ifend
 !ifend
-get seq /var= !docvar.
-get word /var= word_.#$.
 !if (!trvnfe) !then
  !let !rel1= 'comp relv= trv(stpos(d1):endpos(d1))' !let !rel2= 'comp rel= relv*make(1,nrow(seq2),1)' !let !rel3= 'comp m= m&*rel'
- get trv /var= relev_.#$ /miss= 0.
- do if any(trv<0) or any(trv>1).
-  print /title '>ERROR. В векторе TRV не все значения лежат в диапазоне [0,1].'.
-  comp ok= 0.
- end if.
 !ifend
 !if (!trsmnfe) !then
- get trsm /file= 'temp_KO_seqsim_2.sav'.
- comp term= t(trsm(:,ncol(trsm))).
- comp tones= make(1,ncol(term),1).
- comp tnums= 1:ncol(term).
- comp trsm(:,ncol(trsm))= make(nrow(trsm),1,0).
- comp trsm= {trsm;make(1,ncol(trsm),0)}.
- do if ncol(trsm)<>nrow(trsm).
-  print /title '>ERROR. Матрица TRSM не квадратна.'.
-  comp ok= 0.
- else if any(trsm<>t(trsm)).
-  print /title '>ERROR. Матрица TRSM не симметрична.'.
-  comp ok= 0.
- else if any(trsm<0) or any(trsm>1).
-  print /title '>ERROR. В матрице TRSM не все значения лежат в диапазоне [0,1].'.
-  comp ok= 0.
- end if.
- comp trsm(nrow(trsm),ncol(trsm))= -!trtr.
 !ifend
-do if any(seq=' ').
- print /title '>ERROR. DOCVAR-переменная имеет пустые значения.'.
- comp ok= 0.
-end if.
-comp seqs= seq(1).
-comp stpos= 1.
-loop i= 2 to nrow(seq).
- do if not any(seq(i)=seqs).
-  comp seqs= {seqs;seq(i)}.
-  comp stpos= {stpos;i}.
- end if.
-end loop.
-comp endpos= {(stpos-1)(2:nrow(stpos));nrow(seq)}.
 !if (!savem1<>!null !or !savem2<>!null) !then
- do if nrow(seqs)>2.
-  print /title '>ERROR. Задано SAVEM1/SAVEM2, но входящих последовательностей больше двух.'.
-  comp ok= 0.
- end if.
 !ifend
 !if (!diag<>!null !and !diagls<>!null) !then
- comp locat= !head(!diagls).
- comp shape= !tail(!diagls).
- do if locat<=0 or locat>=1 or shape<1.
-  print /title '>ERROR. Неверно заданы один или оба параметра DIAGLS.'.
-  comp ok= 0.
- end if.
 !ifend
-do if ok.
- print /title '**** СРАВНЕНИЕ ПОСЛЕДОВАТЕЛЬНОСТЕЙ ****'.
  !if (!firstext) !then
-  print /title 'COMPARE=FIRSTEXT: Макрос сопоставит 1-ю последовательность с каждой'.
-  print /title 'прочей и извлечет в каждом сопоставлении длиннейшую' /space= 0.
-  print /title 'общую цепочку.' /space= 0.
-  print /title '>REMINDER. При COMPARE=FIRSTEXT макрос игнорирует подкоманды'.
-  print /title ' CHMAXW/CHMINW, CHBWARD, TRV/TRSM/TROTR, DIAG/DIAGLS, RESCRND, METHOD,' /space= 0.
-  print /title ' DLEN/DIVISOR/WMAX, PRINT, которые используются при вычислении меры сходства.' /space= 0.
  !else
   !if (!compare='FIRST') !then
-   print /title 'COMPARE=FIRST: Макрос сравнит 1-ю последовательность с каждой прочей'.
-   print /title 'и вычислит в каждом сравнении сходство (величину совпадения).' /space= 0.
   !else
-   print /title 'COMPARE=ALLPAIRS (default): Макрос сравнит последовательности попарно'.
-   print /title 'и вычислит в каждом сравнении сходство (величину совпадения).' /space= 0.
   !ifend
   !if (!trvnfe !or !trsmnfe) !then
-   print /title 'Учет релевантностей (или релевантностей и схожестей) терминов: Yes'.
   !else
-   print /title 'Учет релевантностей (или релевантностей и схожестей) терминов: No'.
   !ifend  
   !if (!mxw<>1) !then
-   print /title 'Ценение общих подпоследовательностей смежных слов: Yes' /space= 0.
   !else
-   print /title 'Ценение общих подпоследовательностей смежных слов: No' /space= 0.
   !ifend
   !if (!diag<>!null) !then
-   print /title 'Проверка диагональности (сходного расположения): Yes' /space= 0.
   !else
-   print /title 'Проверка диагональности (сходного расположения): No' /space= 0.
   !ifend
-  print /title !quote(!conc('Для определения величины сходства будет использован метод: ',!head(!method))) /space= 0.
-  print /title !if(!head(!method)='GREEDY') !then '(максимальное паросочетание жадным алгоритмом)'
                !else !if(!method='HUNGAR') !then '(максимальное паросочетание венгерским алгоритмом)'
                !else !if(!method='MXTRACE') !then '(максимальное выравнивание)'
                !else !if(!method='MXCHW') !then '(максимальная общая цепочка)'
                !else !if(!method='MXW') !then '(максимальный вес)'
                !else !if(!method='MEANPW') !then '(усредненный положительный вес)'
                !else !if(!method='SUM') !then '(сумма весов)'
                !ifend !ifend !ifend !ifend !ifend !ifend !ifend /space= 0.
   !if (!chbward='YES' !and !method='MXTRACE') !then
-   print /title '>WARNING. METHOD=MXTRACE в сочетании с CHBWARD=YES возможен,'.
-   print /title '>но это необычное задание.' /space= 0.
   !ifend
   !if (!dlen='NONE') !then
-   print /title 'Нормирование сходства: No' /space= 0.
   !else
-   print /title 'Нормирование сходства: Yes' /space= 0.
   !ifend
  !ifend
- print nrow(word) /title 'Число наблюдений в анализе:'.
- comp n= endpos-stpos+1.
- loop i= 1 to nrow(seqs).
-  comp n(i)= n(i)-csum(not word(stpos(i):endpos(i))).
- end loop.
- print nrow(seqs) /title 'Число входящих последовательностей:'.
- print n /title 'Число слов в каждой последовательности ("длина документа", без разрывов):' /rnam= seqs.
- print msum(n) /title '-----' /rlab= 'Total:' /space= 0.
  !if (!print<>!null !or !firstext) !then
-  print /title '-------------'.
  !ifend
  !if (!compare='FIRST' !or !firstext) !then !let !stop= 1
-  comp sim= make(1,!if (!firstext) !then 2 !else nrow(seqs) !ifend,0).
   !if (!savemxaw<>!null) !then
-   comp mxwsav= make(1,nrow(seqs),0).
   !ifend
  !else !let !stop= 'nrow(seqs)-1'
-  comp sim= make(nrow(seqs),nrow(seqs),0).
   !if (!savemxaw<>!null) !then
-   comp mxwsav= make(nrow(seqs),nrow(seqs),0).
   !ifend
  !ifend
  !if (!not !firstext !and !dlen<>'NONE' !and !wxw<>1) !then
-  comp wmax= !if (!wmax=!null) !then 0 !else !wmax !ifend.
   !if (!compare='FIRST') !then
-   comp wulim= make(1,nrow(seqs),0).
   !else
-   comp wulim= make(nrow(seqs),nrow(seqs),0).
   !ifend
  !ifend
- loop d1= 1 to !stop.
-  comp seq1= word(stpos(d1):endpos(d1)).
   !if (!trsmnfe) !then
-   comp @mat= term(make(1,nrow(seq1),1),:).
-   comp @val= seq1*tones.
-   comp @mat= (@mat=@val)&*tnums(make(1,nrow(@mat),1),:).
-   comp tind1= rmax(@mat).
-   release @mat,@val.
-   comp tind1= tind1+(not tind1)*nrow(trsm).
-   comp trsm1= trsm(tind1,:).
   !ifend
-  !rel1.
-  loop d2= d1+1 to nrow(seqs).
-   comp seq2= word(stpos(d2):endpos(d2)).
    !if (!trsmnfe) !then
-    comp @mat= term(make(1,nrow(seq2),1),:).
-    comp @val= seq2*tones.
-    comp @mat= (@mat=@val)&*tnums(make(1,nrow(@mat),1),:).
-    comp tind2= rmax(@mat).
-    release @mat,@val.
-    comp tind2= tind2+(not tind2)*ncol(trsm).
-    comp m= trsm1(:,tind2).
-    comp m2= seq1*make(1,nrow(seq2),1)=t(seq2)(make(1,nrow(seq1),1),:).
-    comp m3= m<0. 
-    comp m= m+m3*!trtr&*(1+m2).
-    release m3 !if (!mxw=1) !then ,m2 !ifend.
    !else
-    comp m= seq1*make(1,nrow(seq2),1)=t(seq2)(make(1,nrow(seq1),1),:).
    !ifend
-   !rel2.
-   !rel3.
    !if (!savem1<>!null) !then
-    save {-999,t(seq2);seq1,m} /out= !savem1 /vari= seq1 w1 to w10000.
-    print /title 'Начальная матрица совстреч сохранена как файл/массив'.
-    print /title !savem1 /space= 0.
-    print /title 'Ее 1-й столбец и 1-й ряд - "слова" в кодировке переменной word_.#$.' /space= 0.
-    do if not any(m).
-     print /title 'Матрица пуста.' /space= 0.
-    end if.
    !ifend
    !if (!index(!method,'PRINT')>0 !and !not !firstext) !then !let !wprint= 1
-    comp nw= make(!mxw-!mnw+1,3,0).
    !ifend
-   do if any(m).
     !if (!mxw<>1) !then
      !if (!trsmnfe) !then
-      comp m_#= m.
-      comp m= (m&*m2>=!head(!chpass))+(m&*(not m2)>=!tail(!chpass)).
-      release m2.
      !else !if (!trvnfe) !then
-      comp m_#= m.
-      comp m= m>=!head(!chpass).
      !ifend !ifend
     !ifend
     !if (!firstext) !then
-     comp lench= 0.
      !do !pass= 1 !to 2
       !if (!pass=1) !then !let !n= 'ncol(m)' !let !s= ':,corn:ncol(m)'
       !else !let !n= 'nrow(m)' !let !s= 'corn:nrow(m),:'
       !ifend
-      loop corn= !pass to !n.
-       comp sm= m(!s).
-       comp vec= diag(sm).
-       comp i= 1.
-       loop.
-        loop st= i to nrow(vec)-1.
-        end loop if vec(st).
-        do if st>=nrow(vec).
-         break.
-        end if.
-        loop i= st to nrow(vec) if vec(i).
-        end loop.
-        do if i-st>lench.
-         comp lench= i-st.
-         comp rstch= !if (!pass=1) !then st !else corn+st-1 !ifend.
-         comp numch= 1.
-        else if i-st=lench.
-         comp numch= numch+1.
-        end if.
-        comp vec(st:(i-1))= make(i-st,1,i-st).
-       end loop.
-       call setdiag(sm,vec).
-       comp m(!s)= sm.
-      end loop.
      !doend
-     release sm,vec.
     !else !if (!mxw<>1) !then
      !if (!chbward='YES') !then !let !mm= 'm m_'
-      comp m_= m(:,ncol(m):1).
      !else !let !mm= 'm'
      !ifend
      !if (!mxw<>'NOLIM') !then
-      do if !mxw=2 or !mxw=3 and nrow(m)*ncol(m)<40000 or !mxw=4 and nrow(m)*ncol(m)<2500.
        !do !m !in (!mm)
-        loop w= 2 to rmin({!mxw,nrow(m),ncol(m)}).
-         comp w_= w-1.
-         comp a= !m(1:(nrow(m)-w_),1:(ncol(m)-w_)).
-         comp b= a.
-         loop i= 2 to w.
-          comp b= b and !m(i:(nrow(m)-w+i),i:(ncol(m)-w+i)).
-         end loop.
-         comp !m(1:(nrow(m)-w_),1:(ncol(m)-w_))= a+b.
-         loop i= 1 to w_.
-          comp a= !m(2:nrow(m),2:ncol(m)).
-          comp b= !m(1:(nrow(m)-1),1:(ncol(m)-1)).
-          comp !m(2:nrow(m),2:ncol(m))= a+(a=w_)&*(b=w).
-         end loop.
-        end loop.
-        release a,b.
        !doend
-      else.
      !ifend
        !do !m !in (!mm)
-        comp nc= ncol(m).
-        loop i= 2 to nrow(m).
-         comp r= !m(i,2:nc).
-         comp r_= !m(i-1,1:(nc-1)).
          !if (!mxw='NOLIM') !then
-          comp !m(i,2:nc)= r&*(r_+1).
          !else
-          comp !m(i,2:nc)= r&*(r_+(r_<!mxw)).
          !ifend
-        end loop.
-        loop i= nrow(m)-1 to 1 by -1.
-         comp r= !m(i,1:(nc-1)).
-         comp r_= !m(i+1,2:nc).
-         comp rr_= r and r_.
-         comp !m(i,1:(nc-1))= r_&*rr_+r&*(not rr_).
-        end loop.
-        release r,r_,rr_.
        !doend
      !if (!mxw<>'NOLIM') !then
-      end if.
      !ifend
      !if (!chbward='YES') !then
-      comp m_= m_(:,ncol(m):1).
-      comp m= m&*(m>=m_)+m_&*(m<m_).
-      release m_.
      !ifend
     !ifend !ifend
   !if (!firstext) !then
-    comp seq2= seq1(rstch:(rstch+lench-1)).
-    comp sim= {sim;{make(nrow(seq2),1,seqs(d2)),seq2}}.
-    do if numch>1.
-     print seqs(d2) /title '>NOTE. Между 1-й последовательностью и последовательностью' /format= a8.
-     print /title ' наидлиннейших общих цепочек одинаковой длины' /space= 0.
-     print numch /title ' найдено несколько, а именно' /space= 0.
-     print /title ' Только одна из них показана в выходящем массиве.' /space= 0.
-    end if.
-   else.
-    comp sim= {sim;{seqs(d2),-999}}.
-    print seqs(d2) /title '>NOTE. Между 1-й последовательностью и последовательностью' /format= a8.
-    print /title ' общих слов не найдено.' /space= 0.
   !else
    !if (!mnw>1) !then
     !if (!tail(!chminw)=!null) !then
-     comp m= m&*(m>=!mnw).
     !else !if (!mnw>2) !then
-     comp m= m-((m<!mnw)-(not m))&*(m-1).
     !ifend !ifend
    !ifend
    !if (!tail(!chmaxw)=' SQUARE') !then !let !square= 1 !let !w_= '#w'
-    comp m= m&*m.
    !ifend
    !if (!mxw<>1) !then
-    comp mxaw= mmax(m).
    !ifend
    !if (!method='MXCHW') !then
-    do if mxaw>1.
-     comp om= m(1:(nrow(m)-1),1:(ncol(m)-1)).
-     comp om= {0,make(1,ncol(om),0);make(nrow(om),1,0),om}.
-     comp om= (m=mxaw)&*(om<>mxaw).
-     comp @flag= om<>0.
-     comp om2= csum(@flag).
-     comp @m= @flag.
-     loop @i= 2 to nrow(@m).
-      comp @m(@i,:)= @m(@i-1,:)+@m(@i,:).
-     end loop.
-     comp @m= @m&*@flag.
-     release @flag.
-     comp om= make(nrow(@m)+1,ncol(@m),0).
-     comp @nums= t(1:nrow(@m)).
-     comp @m= @m+(not @m)*nrow(om).
-     loop @i= 1 to ncol(@m).
-      comp om(@m(:,@i),@i)= @nums.
-     end loop.
-     comp om= om(1:mmax(om2),:).
-     release @m,@i,@nums.
-    end if.
    !ifend
    !if (!savemxaw<>!null) !then
     !if (!mxw=1) !then !let !mxawt= 'Веса - из начальной матрицы совстреч.'
-     comp mxwsav(d1,d2)= mmax(m).
     !else !let !mxawt= 'Веса - на момент окончания пометки цепочек (CHMAXW/CHMINW).'
-     comp mxwsav(d1,d2)= mxaw.
     !ifend
    !ifend
    !if ((!trsmnfe !or !trvnfe) !and !mxw<>1) !then
-    comp m= m&*m_#.
-    release m_#.
    !ifend
    !if (!mxw<>1) !then
-    do if any(m).
    !ifend
     !if (!diag<>!null) !then !let !mbfrac= 1
-     comp nr= nrow(m).
-     comp nc= ncol(m).
-     comp o1= (1:nc)(make(1,nr,1),:).
-     comp o2= t(1:nr)*make(1,nc,1).
-     comp diff= abs(nr-nc).
-     do if not diff.
-      comp off= o1-o2.
-     else.
       !if (!diag='MAIN' !or !diag='MIDDLE') !then
-       comp off= o1-o2.
        !if (!diag='MIDDLE') !then
-        comp shift= trunc(diff/2).
-        do if nr<nc.
-         comp off= off-shift.
-         do if mod(diff,2).
-          comp off= off-(off>0).
-         end if.
-        else.
-         comp off= off+shift.
-         do if mod(diff,2).
-          comp off= off+(off<0).
-         end if. 
-        end if.
        !ifend
       !else
-       do if nr<nc.
-        loop i= 1 to nr.
-         comp o1(i,1:diff+i)= make(1,diff,i).
-        end loop.
-        comp off= o1-o2.
-        comp off= off-(off>0)*diff.
-       else.
-        loop i= 1 to nc.
-         comp o2(1:diff+i,i)= make(diff,1,i).
-        end loop.
-        comp off= o1-o2.
-        comp off= off+(off<0)*diff.
-       end if.
       !ifend
-     end if.
-     comp off= (m>0)&*abs(off).
-     comp offp= off>0.
-     comp o1= rsum(offp).
-     comp o2= csum(offp).
-     release offp.
-     comp o1z= o1=0.
-     comp o2z= o2=0.
-     comp o1= rsum(off)/((o1+o1z)*nc).
-     comp o2= csum(off)/((o2+o2z)*nr).
      !if (!diagls<>!null) !then
-      do if locat<>.5 or shape<>1.
-       comp o1= o1+o1z/2.
-       comp o1= o1&*(o1<1)+.5*(o1>=1).
-       comp o1= 1/(1+(o1*(1-locat)/(locat*(1-o1)))&**(-shape)).
-       comp o1= o1&*(not o1z).
-       comp o2= o2+o2z/2.
-       comp o2= o2&*(o2<1)+.5*(o2>=1).
-       comp o2= 1/(1+(o2*(1-locat)/(locat*(1-o2)))&**(-shape)).
-       comp o2= o2&*(not o2z).
-      end if.
      !ifend
-     comp o1= 1-o1.
-     comp o2= 1-o2.
-     comp off= sqrt(abs(o1*o2)).
      !if (!diag='MAIN') !then
-      do if nr<nc.
-       comp off(:,(nr+1):nc)= o1*make(1,diff,1).
-      else if nr>nc.
-       comp off((nc+1):nr,:)= o2(make(1,diff,1),:).
-      end if.
      !else !if (!diag='MIDDLE') !then
-      comp diff= (diff-mod(diff,2))/2.
-      do if diff.
-       do if nr<nc.
-        comp off(:,{1:diff,(nc-diff+1):nc})= o1*make(1,2*diff,1).
-       else if nr>nc.
-        comp off({1:diff,(nr-diff+1):nr},:)= o2(make(1,2*diff,1),:).
-       end if.
-      end if.
      !ifend !ifend
-     comp m= m&*off.
-     release off,o1,o2,o1z,o2z.
     !ifend
     !if (!rescrnd<>!null !and !mbfrac) !then
      !let !ceil= !conc('1E',!rescrnd) !let !rndtit= '(После округления) '
      !if (!print='MEDIUM' !or !print='LONG') !then
-      print t(seqs({d1,d2})) /title '(До округления) Совстречи - ненулевые значения в матр. совстреч между' /format= a8.
-      comp @vec= reshape(m,nrow(m)*ncol(m),1).
-      comp numvals= @vec(1).
-      comp name2= 1.
-      loop @i= 2 to nrow(@vec).
-       do if not any(@vec(@i)=numvals).
-        comp numvals= {numvals;@vec(@i)}.
-        comp name2= {name2;@i}.
-       end if.
-      end loop.
-      print (nrow(numvals)-1) /title 'Разнообразие весов совстреч, count:' /space= 0.
-      release @vec,name2,numvals.
       !if (!print='LONG') !then
-       print /title 'Матрица совстреч до округления'.
-       print /title '(1-й ряд и столбец - "слова" в кодировке переменной word_.#$;' /space= 0.
-       print {-999,t(seq2);seq1,m} /title 'произвольные отриц. знач-я среди них, если есть - это разрывы):' /format= f7.4 /space= 0.
       !ifend
      !ifend
-     comp resc= !ceil/mmax(m).
-     comp m2= m.
-     comp m= rnd(m*resc)/resc.
-     comp m= m+(m2 and not m)*1E-9.
-     release m2.
     !ifend
     !if (!print='MEDIUM' !or !print='LONG') !then
-     print t(seqs({d1,d2})) /title !quote(!conc(!rndtit,'Совстречи - ненулевые значения в матр. совстреч между')) /format= a8.
-     print /title 'перед начислением сходства' /space= 0.
      !if (!mxw<>1 !or !mbfrac) !then
-      comp @vec= reshape(m,nrow(m)*ncol(m),1).
-      comp numvals= @vec(1).
-      comp name2= 1.
-      loop @i= 2 to nrow(@vec).
-       do if not any(@vec(@i)=numvals).
-        comp numvals= {numvals;@vec(@i)}.
-        comp name2= {name2;@i}.
-       end if.
-      end loop.
-      print (nrow(numvals)-1) /title 'Разнообразие весов совстреч, count:' /space= 0.
-      release @vec,name2,numvals.
      !ifend
-     print (msum(m>0)/(nrow(m)*ncol(m))*100) /title 'Плотность совстреч в матрице, %:' /format= f8.1 /space= 0.
      !if (!print='LONG') !then
-      print /title 'Матрица совстреч перед начислением сходства'.
-      print /title '(1-й ряд и столбец - "слова" в кодировке переменной word_.#$;' /space= 0.
-      print {-999,t(seq2);seq1,m} /title 'произвольные отриц. знач-я среди них, если есть - это разрывы):' /format=
           !if (!mbfrac) !then f7.4 !else f4 !ifend /space= 0.
      !ifend
      !if (!mxw<>1) !then
-      print /title 'Максимальный вес (w_max), бывший в матрице совстреч в момент'.
-      print mxaw /title 'окончания пометки цепочек:' /space= 0.
      !ifend
     !ifend
     !if (!savem2<>!null) !then
-     save {-999,t(seq2);seq1,m} /out= !savem2 /vari= seq1 w1 to w10000.
-     print /title 'Конечная до начисл. сходства матрица совстреч сохранена как файл/массив'.
-     print /title !savem2 /space= 0.
-     print /title 'Ее 1-й столбец и 1-й ряд - "слова" в кодировке переменной word_.#$.' /space= 0.
     !ifend
     !if (!method='SUM') !then
-     comp sim(d1,d2)= msum(m).
     !else !if (!method='MXW') !then
-     comp sim(d1,d2)= mmax(m).
     !else !if (!method='MEANPW') !then
-     comp sim(d1,d2)= msum(m)/msum(m>0).
     !else !if (!method='MXCHW') !then
-     do if mxaw>1.
-      comp indvec= 0:(!if (!square) !then sqrt !ifend (mxaw)-1).
-      loop j= 1 to ncol(om).
-       loop i= 1 to om2(j).
-        comp rinds= om(i,j)+indvec.
-        comp cinds= j+indvec.
-        comp tr= trace(m(rinds,cinds)).
         !if (!mxw<>'NOLIM') !then
-         comp lrind= rinds(ncol(rinds))+1.
-         comp lcind= cinds(ncol(cinds))+1.
-         loop if lrind<=nrow(m) and lcind<=ncol(m).
-          do if m(lrind,lcind).
-           comp tr= tr+m(lrind,lcind).
-           comp lrind= lrind+1.
-           comp lcind= lcind+1.
-          else.
-           break.
-          end if.
-         end loop.
         !ifend
-        comp sim(d1,d2)= mmax({sim(d1,d2),tr}).
-       end loop.
-      end loop.
-     else.
-      comp sim(d1,d2)= mmax(m).
-     end if.
     !else !if (!method='MXTRACE') !then
-     comp trup= make(1,ncol(m),0).
-     loop i= 1 to ncol(m).
-      comp trup(i)= trace(m(:,i:ncol(m))).
-     end loop.
-     comp trlo= make(1,nrow(m),0).
-     loop i= 2 to nrow(m).
-      comp trlo(i)= trace(m(i:nrow(m),:)).
-     end loop.
-     comp sim(d1,d2)= mmax({trup,trlo}).
     !else
      !do !pass !in ('"rmax nzr" "cmax nzc"')
       !let !pss= !unquote(!pass) !let !max= !head(!pss) !let !ind= !tail(!pss)
-      comp @vec= !max(m)<>0.
-      comp @n= nrow(@vec)*ncol(@vec).
-      comp @nnz= msum(@vec).
-      do if @nnz=@n.
-       comp !ind= 1:@n.
-      else if @nnz/@n>.8.
-       comp !ind= make(1,@nnz+1,0).
-       comp @c= 1.
-       loop @i= 1 to @n.
-        comp !ind(@c)= @i.
-        comp @c= @c+@vec(@i).
-       end loop.
-       comp !ind= !ind(1:@nnz).
-      else if @nnz/@n<.08.
-       comp !ind= make(1,@nnz,0).
-       comp @s= 1.
-       loop @c= 1 to @nnz.
-        loop @i= @s to @n.
-        end loop if @vec(@i).
-        comp !ind(@c)= @i.
-        comp @s= @i+1.
-       end loop.
-      else.
-       comp !ind= make(1,@nnz,0).
-       comp @c= 0.
-       loop @i= 1 to @n.
-        do if @vec(@i).
-         comp @c= @c+1.
-         comp !ind(@c)= @i.
-        end if.
-       end loop.
-      end if.
      !doend
-     comp m= m(nzr,nzc).
-     do if nrow(m) !if (!method='HUNGAR') !then <ncol(m) !else >2*ncol(m) !ifend.
-      comp m= t(m).
-     end if.
      !if (!method='HUNGAR') !then
-      comp m#= mmax(m)-m.
-      do if nrow(m#)>ncol(m#).
-       comp m#= {m#,make(nrow(m#),nrow(m#)-ncol(m#),0)}.
-      end if.
-      comp @n= nrow(m#).
-      comp @rzero= make(1,@n,0).
-      comp @czero= make(@n,1,0).
-      comp @rnums= t(1:@n).
-      comp @cnums= 1:@n.
-      comp m#= m#-rmin(m#)*make(1,@n,1).
-      comp @m= (not m#)&*@cnums(make(1,@n,1),:).
-      loop @i= 1 to @n.
-       comp @j= rmax(@m(@i,:)).
-       do if @j.
-        comp @m(@i,:)= @rzero.
-        comp @m(:,@j)= @czero.
-        comp @m(@i,@j)= 1.
-       end if.
-      end loop.
-      loop.
-       comp @ucr= make(@n,1,1).
-       comp @ucc= not csum(@m).
-       do if not any(@ucc).
-        break.
-       else.
-        loop.
-         comp @i= 0.
-         loop @j= 1 to @n.
-          do if @ucc(@j).
-           comp @i= cmax((not m#(:,@j))&*@ucr&*@rnums).
-           do if @i.
-            break.
-           end if.
-          end if.
-         end loop.
-         do if @i.
-          comp @m(@i,@j)= -2.
-          do if any(@m(@i,:)=1).
-           comp @ucr(@i)= 0.
-           comp @ucc(rmax(@m(@i,:)&*@cnums))= 1.
-          else.
-           comp @m(@i,@j)= -3.
-           loop if any(@m(:,@j)=1).
-            comp @i2= cmax(@m(:,@j)&*@rnums).
-            comp @m(@i2,@j)= 0.
-            comp @j2= rmax((@m(@i2,:)=-2)&*@cnums).
-            comp @m(@i2,@j2)= -3.
-            comp @j= @j2.
-           end loop.
-           comp @m= @m&*(@m<>-3)+(@m=-3).
-           comp @m= @m&*(@m<>-2).
-           break.
-          end if.
-         else.
           !do !w !in ("'@ucr @rind' '@ucc @cind'")
            !let !w0= !unquote(!w) !let !w1= !head(!w0) !let !w2= !tail(!w0)
-           comp @nnz= msum(!w1).
-           do if @nnz=@n.
-            comp !w2= @cnums.
-           else if @nnz/@n>.8.
-            comp !w2= make(1,@nnz+1,0).
-            comp @cnt= 1.
-            loop @#= 1 to @n.
-             comp !w2(@cnt)= @#.
-             comp @cnt= @cnt+!w1(@#).
-            end loop.
-            comp !w2= !w2(1:@nnz).
-           else.
-            comp !w2= make(1,@nnz,0).
-            comp @cnt= 0.
-            loop @#= 1 to @n.
-             do if !w1(@#).
-              comp @cnt= @cnt+1.
-              comp !w2(@cnt)= @#.
-             end if.
-            end loop.
-           end if.
           !doend
-          comp @min= mmin(m#(@rind,@cind)).
-          comp m#= m#+(not @ucr)*make(1,@n,@min)-make(@n,1,@min)*@ucc.
-          release @nnz,@rind,@cind,@cnt,@#.
-         end if.
-        end loop.
-       end if.
-      end loop.
-      loop @j= 1 to ncol(m).
-       comp @i= cmax(@m(:,@j)&*@rnums).
-       comp sim(d1,d2)= sim(d1,d2)+m(@i,@j).
-      end loop.
-      release m#,@m.
      !else
       !if (!index(!method,'REORD')>0) !then
-       comp m(grade(-rsum(m)),grade(-csum(m)))= m.
       !ifend
       !if (!wprint) !then
-       loop w= !mxw to !mnw by -1.
         !if (!square) !then
-         comp nw(!mxw-w+1,1:2)= {w**2,msum(m=w**2)}.
         !else
-         comp nw(!mxw-w+1,1:2)= {w,msum(m=w)}.
         !ifend
-       end loop.
       !ifend
-      comp size= rmin({nrow(m),ncol(m)}).
-      comp @cnt= 0.
       !if (!wprint) !then
-       comp maxw= mmax(m).
        !if (!square) !then
-        loop #w= sqrt(maxw) to !mnw by -1.
-         comp w= #w**2.
        !else
-        loop w= maxw to !mnw by -1.
        !ifend
-         comp nw(!mxw-!w_+1,3)= sim(d1,d2).
       !else
-        loop. 
-         comp w= mmax(m).
-         do if not w.
-          break.
-         end if.
       !ifend
-         comp @rind= 0.
-         comp @cnums= 1:ncol(m).
-         loop @ri= nrow(m) to 1 by -1.
-          comp @ci= rmax((m(@ri,:)=w)&*@cnums).
-          do if @ci.
-           comp @cnt= @cnt+1.
-           comp sim(d1,d2)= sim(d1,d2)+w.
-           comp @cnums(@ci)= 0.
-          else.
-           comp @rind= {@ri,@rind}.
-          end if.
-         end loop.
       !if (!wprint) !then
-         comp nw(!mxw-!w_+1,3)= (sim(d1,d2)-nw(!mxw-!w_+1,3))/w.
       !ifend
-         do if @cnt=size.
-          break.
-         end if.
-         comp @rind= @rind(1:(ncol(@rind)-1)).
-         comp @vec= @cnums<>0.
-         comp @n= ncol(@vec).
-         comp @nnz= msum(@vec).
-         do if @nnz/@n>.8.
-          comp @cind= make(1,@nnz+1,0).
-          comp @c= 1.
-          loop @i= 1 to @n.
-           comp @cind(@c)= @i.
-           comp @c= @c+@vec(@i).
-          end loop.
-          comp @cind= @cind(1:@nnz).
-         else.
-          comp @cind= make(1,@nnz,0).
-          comp @c= 0.
-          loop @i= 1 to @n.
-           do if @vec(@i).
-            comp @c= @c+1.
-            comp @cind(@c)= @i.
-           end if.
-          end loop.
-         end if.
-         comp m= m(@rind,@cind).
-        end loop.
       !if (!wprint) !then
-       print t(seqs({d1,d2})) /title 'Число совстреч одинаковых слов между' /format= a8.
-       print nw /title ' ' /clab= '(Weight)' 'Total' 'Useful' /space= 0.
-       print sim(d1,d2) /title 'Взвешенная Weight сумма Useful дает сырое сходство:' /space= 0.
        !if (!print=!null) !then
-        print /title '-------------'.
        !ifend
       !ifend
      !ifend
     !ifend !ifend !ifend !ifend !ifend
     !if (!mxw<>1) !then
      !if (!print<>!null !or !savem2<>!null) !then
-      else.
        !if (!print<>!null) !then
-        print t(seqs({d1,d2})) /title 'Матрица совстреч между' /format= a8.
-        print /title 'стала пуста в ходе пометки цепочек, например из-за' /space= 0.
-        print /title 'параметра CHMINW или CHPASS' /space= 0.
        !ifend
        !if (!savem2<>!null) !then
-        save {-999,t(seq2);seq1,m} /out= !savem2 /vari= seq1 w1 to w10000.
-        print /title 'Конечная до начисл. сходства матрица совстреч сохранена как файл/массив'.
-        print /title !savem2 /space= 0.
-        print /title 'Ее 1-й столбец и 1-й ряд - "слова" в кодировке переменной word_.#$.' /space= 0.
-        print /title 'Матрица пуста.' /space= 0.
        !ifend
      !ifend
-     end if.
     !ifend
     !if (!dlen<>'NONE' !and !mxw<>1) !then
      !if (!divisor='DIVISOR1') !then
-      comp wulim(d1,d2)= mxaw.
      !else
       !if (!wmax=!null) !then
-       do if mxaw>wmax.
-        comp wmax= mxaw.
-       end if.
       !ifend
       !if (!divisor<>'DIVISOR2') !then
-       comp wulim(d1,d2)= (mmin({n(d1),n(d2) !if (!mxw<>'NOLIM') !then ,!mxw !ifend})) !if (!square) !then **2 !ifend.
       !ifend
      !ifend
     !ifend
     !if (!print<>!null !or !savem2<>!null) !then
-     else.
       !if (!print<>!null) !then
-       print t(seqs({d1,d2})) /title 'Матрица совстреч между' /format= a8.
-       print /title 'пуста изначально' /space= 0.
       !ifend
       !if (!savem2<>!null) !then
-       save {-999,t(seq2);seq1,m} /out= !savem2 /vari= seq1 w1 to w10000.
-       print /title 'Конечная до начисл. сходства матрица совстреч сохранена как файл/массив'.
-       print /title !savem2 /space= 0.
-       print /title 'Ее 1-й столбец и 1-й ряд - "слова" в кодировке переменной word_.#$.' /space= 0.
-       print /title 'Матрица пуста.' /space= 0.
       !ifend
     !ifend
   !ifend
-   end if.
    !if (!print<>!null !and !not !firstext) !then
-    print t(seqs({d1,d2})) /title 'Сырое сходство между' /format= a8.
-    print sim(d1,d2) /title= ' ' /space= 0 /format= f8.3.
-    print /title '-------------'.
    !ifend
-  end loop.
- end loop.
  !if (!not !firstext !and !dlen<>'NONE' !and !wxw<>1) !then
   !if (!divisor='DIVISOR2') !then
-   do if wmax.
-    comp sim= sim/wmax.
-   end if.
   !else
    !if (!compare<>'FIRST') !then
-    comp wulim= wulim+t(wulim).
    !ifend
-   comp wulim= wulim+(not wulim).
    !if (!divisor='DIVISOR1') !then
-    comp sim= sim/wulim.
    !else
-    do if wmax.
      !if (!divisor='DIVISOR4') !then
-      comp sim= sim/(2*wmax&*wulim/(wmax+wulim)).
      !else
-      comp sim= sim/(wmax*(wmax<=wulim)+wulim&*(wmax>wulim)).
      !ifend
-    end if.
    !ifend
   !ifend
  !ifend
  !if (!firstext) !then
-  save sim(2:nrow(sim),:) /out= * /vari= !docvar word_.#$ /string= !docvar.
  !else !if (!compare='FIRST') !then
-  comp sim= t(sim(2:ncol(sim))).
   !if (!dlen<>'NONE') !then
-   comp n1= n(1).
-   comp n= n(2:nrow(n)).
    !if (!dlen='MAX') !then
-    comp sim= sim/(((n1>=n)&*n1+(n1<n)&*n)).
    !else !if (!dlen='MEAN') !then
-    comp sim= sim/((n1+n)/2).
    !else !if (!dlen='GMEAN') !then
-    comp sim= sim/sqrt(n1*n).
    !else !if (!dlen='HMEAN') !then
-    comp sim= sim/(2*n1*n/(n1+n)).
    !else
-    comp sim= sim/(((n1<=n)&*n1+(n1>n)&*n)).
    !ifend !ifend !ifend !ifend
   !ifend
-  comp rowtype= make(nrow(sim),1,'PROX').
-  comp nam= {'rowtype_','varname_',seqs(1)}.
-  save {rowtype,seqs(2:nrow(seqs)),sim} /out= * /names= nam /string= rowtype_ varname_.
   !if (!savemxaw<>!null) !then
-   comp nam= nam(2:ncol(nam)).
-   save {seqs(2:nrow(seqs)),t(mxwsav(2:ncol(mxwsav)))} /out= !savemxaw /names= nam /string= varname_.
-   print /title 'Максимальные набл. веса совстреч сохранены как файл/массив'.
-   print /title !savemxaw /space= 0.
-   print /title !quote(!mxawt) /space= 0.
   !ifend
  !else
-  comp sim= sim+t(sim).
   !if (!dlen<>'NONE') !then
-   comp n= n*make(1,nrow(n),1).
-   comp tn= t(n).
    !if (!dlen='MAX') !then
-    comp sim= sim/(((n>=tn)&*n+(n<tn)&*tn)).
    !else !if (!dlen='MEAN') !then
-    comp sim= sim/((n+tn)/2).
    !else !if (!dlen='GMEAN') !then
-    comp sim= sim/sqrt(n&*tn).
    !else !if (!dlen='HMEAN') !then
-    comp sim= sim/(2*n&*tn/(n+tn)).
    !else
-    comp sim= sim/(((n<=tn)&*n+(n>tn)&*tn)).
    !ifend !ifend !ifend !ifend
-   call setdiag(sim,1).
   !else
-   call setdiag(sim,999).
   !ifend
-  comp rowtype= make(nrow(sim),1,'PROX').
-  comp nam= {'rowtype_','varname_',t(seqs)}.
-  save {rowtype,seqs,sim} /out= * /names= nam /string= rowtype_ varname_.
   !if (!savemxaw<>!null) !then
-   comp mxwsav= mxwsav+t(mxwsav).
-   comp n= n(:,1).
-   call setdiag(mxwsav,n).
-   comp nam= nam(2:ncol(nam)).
-   save {seqs,mxwsav} /out= !savemxaw /names= nam /string= varname_.
-   print /title 'Максимальные набл. веса совстреч сохранены как файл/массив'.
-   print /title !savemxaw /space= 0.
-   print /title !quote(!mxawt) /space= 0.
   !ifend
  !ifend !ifend
-else.
- print /title '>!KO_SEQSIM выполнен неверно.' /space= 0.
- save 0 /out= *.
-end if.
-end matrix.
 !if (!compare='FIRSTEXT') !then
- apply dict from !dtst /source var= word_.#$ /varinfo vallab= replace.
- string !wordvar (a120).
- recode word_.#$ (-999=sysmis).
- comp !wordvar= valuelab(word_.#$).
- exec.
- var lab word_.#$ !quote(!conc('Longest common chain (',!wordvar,' Autorecoded)')) !wordvar 'Longest common chain'.
 !else
- var lev all (sca) rowtype_ varname_ (nom).
- val lab rowtype_ 'PROX' 'SIMILARITY'.
 !ifend
 !if (!trsmnfe) !then
- erase file 'temp_KO_seqsim_1.sat'.
- erase file 'temp_KO_seqsim_2.sav'.
 !ifend
 !if (!newdata<>!null) !then
- dataset name !newdata.
 !ifend
-omsend.
!else
-echo '>!KO_SEQSIM не выполнен.'.
!ifend
!enddefine.
